<?php
# Arastta 1.5.0 Update Synchronised Issue Solved Script
// 1.5.0 changes;
// Update the user groups
$user_groups = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "user_group");

foreach ($user_groups->rows as $user_group) {
    $user_group['permission'] = unserialize($user_group['permission']);

    $user_group['permission']['access'][] = 'tool/cache';
    $user_group['permission']['modify'][] = 'tool/cache';

    $user_group['permission']['access'][] = 'report/graph';
    $user_group['permission']['modify'][] = 'report/graph';

    $user_group['permission']['access'][] = 'system/url_manager';
    $user_group['permission']['modify'][] = 'system/url_manager';

    $user_group['permission']['access'][] = 'analytics/google';
    $user_group['permission']['modify'][] = 'analytics/google';

    $user_group['permission']['access'][] = 'analytics/woopra';
    $user_group['permission']['modify'][] = 'analytics/woopra';

    $user_group['permission']['access'][] = 'antifraud/maxmind';
    $user_group['permission']['modify'][] = 'antifraud/maxmind';

    $user_group['permission']['access'][] = 'captcha/basic';
    $user_group['permission']['modify'][] = 'captcha/basic';

    $user_group['permission']['access'][] = 'captcha/google';
    $user_group['permission']['modify'][] = 'captcha/google';

    $this->db->query("UPDATE " . DB_PREFIX . "user_group SET name = '" . $this->db->escape($user_group['name']) . "', permission = '" . $this->db->escape(serialize($user_group['permission'])) . "' WHERE user_group_id = '" . (int)$user_group['user_group_id'] . "'");
}

// Create user_activity table
$this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "user_activity` (
    `activity_id` int(11) NOT NULL AUTO_INCREMENT,
    `user_id` int(11) NOT NULL,
    `key` varchar(64) NOT NULL,
    `data` text NOT NULL,
    `ip` varchar(40) NOT NULL,
    `date_added` datetime NOT NULL,
    PRIMARY KEY (`activity_id`),
    KEY `user_id` (`user_id`)
    ) DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;");

// Update stock_status table
$stock_status = array();

$query = $this->db->query("SHOW COLUMNS FROM `" . DB_PREFIX . "stock_status`");

if ($query->num_rows) {
    foreach ($query->rows as $row) {
        $stock_status[] = $row['Field'];
    }
}

if (!in_array('preorder', $stock_status)) {
    $this->db->query("ALTER TABLE `" . DB_PREFIX . "stock_status` ADD `preorder` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `color`");
}

// Add maintenance display settings
if ($this->config->get('config_image_maintenance_width', null) == null) {
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '0', `code` = 'config', `key` = 'config_maintenance_message', `value` = ''");
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '0', `code` = 'config', `key` = 'config_maintenance_image', `value` = ''");
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '0', `code` = 'config', `key` = 'config_maintenance_login', `value` = '1'");
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '0', `code` = 'config', `key` = 'config_image_maintenance_width', `value` = '268'");
    $this->db->query("INSERT INTO " . DB_PREFIX . "setting SET store_id = '0', `code` = 'config', `key` = 'config_image_maintenance_height', `value` = '50'");
}

// Update config for new extension types: analytics, anti-fraud, captcha
$this->load->model('setting/setting');

$store_id = $this->config->get('config_store_id');

$config = $this->model_setting_setting->getSetting('config', $store_id);

if ($this->config->get('config_google_captcha_status')) {
    $data = array();

    $data['google_captcha_status'] = '1';
    $data['google_captcha_public'] = $this->config->get('config_google_captcha_public');
    $data['google_captcha_secret'] = $this->config->get('config_google_captcha_secret');

    $this->model_setting_setting->editSetting('google_captcha', $data, $store_id);

    $config['config_captcha'] = 'google';

    $this->model_setting_setting->editSetting('config', $config, $store_id);
} else {
    $config['config_captcha'] = '';

    $this->model_setting_setting->editSetting('config', $config, $store_id);
}

if ($this->config->get('config_google_analytics_status')) {
    $data = array();

    $data['google_analytics_status'] = '1';
    $data['google_analytics_code'] = $this->config->get('config_google_analytics');

    $this->model_setting_setting->editSetting('google_analytics', $data, $store_id);
}

if ($this->config->get('config_fraud_detection')) {
    $data = array();

    $data['maxmind_antifraud_status'] = '1';
    $data['maxmind_antifraud_key'] = $this->config->get('config_fraud_key');
    $data['maxmind_antifraud_score'] = $this->config->get('config_fraud_score');
    $data['maxmind_antifraud_status_id'] = $this->config->get('config_fraud_status_id');

    $this->model_setting_setting->editSetting('maxmind_antifraud', $data, $store_id);
}

// 1.5.1
$this->db->query("DELETE FROM `" . DB_PREFIX . "setting` WHERE `key` = 'basic_status'");
$this->db->query("DELETE FROM `" . DB_PREFIX . "setting` WHERE `key` = 'google_status'");
$this->db->query("DELETE FROM `" . DB_PREFIX . "setting` WHERE `key` = 'maxmind_status'");
$this->db->query("DELETE FROM `" . DB_PREFIX . "setting` WHERE `key` = 'woopra_status'");

// 1.5.2
// remove command folder
$this->filesystem->remove(DIR_SYSTEM . 'library/command');
